var buttonMinWidth = 60;
var buttonMaxWidth = 90;

/*
 * Social Array Definition
 */
var socials = ["facebook", "google", "twitter", "pinterest", "viber", "whatsapp"];

/* 
 * Social Objects Definition
 */
var facebook = {
		isDisplay: false,
		socialButton:"/static/social/fbshare.png",
		shareSourceCode: function(divID, cellID, url, imageURL, title, padding, rowWidth, imageSize){
			return jQuery(divID).append("<div id=\""+cellID+"\" style=\"display: table-cell; padding-left: "+padding+"px; padding-right: "+padding+"px; background-color: #3b5998; cursor: pointer;\"><a onclick=\"openWindow(\'"+"https://www.facebook.com/sharer/sharer.php?u="+url+"\', \'facebook-share-dialog\', \'"+rowWidth+"\', \'"+rowWidth+"\')\"><img src=\""+this.socialButton+"\" width=\""+imageSize+"\"></a></div>");
			}
};

var google = {
		isDisplay: false,
		socialButton:"/static/social/gplusshare.png",
		shareSourceCode: function(divID, cellID, url, imageURL, title, padding, rowWidth, imageSize){
			return jQuery(divID).append("<div id=\""+cellID+"\" style=\"display: table-cell; padding-left: "+padding+"px; padding-right: "+padding+"px; background-color: #da4f48; cursor: pointer;\"><a onclick=\"openWindow(\'"+"https://plus.google.com/share?url="+url+"\', \'google-share-dialog\', \'"+rowWidth+"\', \'"+rowWidth+"\')\"><img src=\""+this.socialButton+"\" width=\""+imageSize+"\"></a></div>");
			}		
};

var twitter = {
		isDisplay: false,
		socialButton:"/static/social/twittershare.png",
		shareSourceCode: function(divID, cellID, url, imageURL, title, padding, rowWidth, imageSize){
			return jQuery(divID).append("<div id=\""+cellID+"\" style=\"display: table-cell; padding-left: "+padding+"px; padding-right: "+padding+"px; background-color: #5EA9DD; cursor: pointer;\"><a onclick=\"openWindow(\'"+"https://twitter.com/share?url="+url+"\', \'twitter-share-dialog\', \'"+rowWidth+"\', \'"+rowWidth+"\')\"><img src=\""+this.socialButton+"\" width=\""+imageSize+"\"></a></div>");
			}		
};

var viber = {
		isDisplay: false,
		socialButton:"/static/social/vibershare.png",
		shareSourceCode: function(divID, cellID, url, imageURL, title, padding, rowWidth, imageSize){
	    	var hrefAttr = "https://app.adjust.com/u783g1_kw9yml?deep_link=" + encodeURIComponent("viber://forward?text=" + encodeURIComponent(title + " " + url)) + "&fallback=https%3A%2F%2Fviber.com";
			return jQuery(divID).append("<div id=\""+cellID+"\" style=\"display: table-cell;  padding-left: "+padding+"px; padding-right: "+padding+"px; background-color: #655ead; cursor: pointer;\"><a href=\""+hrefAttr+"\"><img src=\""+this.socialButton+"\" width=\""+imageSize+"\"></a></div>");
			}		
};

var whatsapp = {
		isDisplay: false,
		socialButton:"/static/social/whatsappshare.png",
		shareSourceCode: function(divID, cellID, url, imageURL, title, padding, rowWidth, imageSize){
	    	var hrefAttr = "whatsapp://send?text=" + encodeURIComponent(title + " "+url);
			return jQuery(divID).append("<div id=\""+cellID+"\" style=\"display: table-cell;  padding-left: "+padding+"px; padding-right: "+padding+"px; background-color: #25d366; cursor: pointer;\"><a href=\""+hrefAttr+"\" data-action=\"share/whatsapp/share\"><img src=\""+this.socialButton+"\" width=\""+imageSize+"\"></a></div>");
			}		
};

var pinterest = {
		isDisplay: false,
		socialButton:"/static/social/pinterestshare.png",
		shareSourceCode: function(divID, cellID, url, imageURL, title, padding, rowWidth, imageSize){
			return jQuery(divID).append("<div id=\""+cellID+"\" style=\"display: table-cell; padding-left: "+padding+"px; padding-right: "+padding+"px; background-color: #bd081c; cursor: pointer;\"><a onclick=\"openWindow(\'"+"http://pinterest.com/pin/create/button/?url="+url+"&media="+encodeURIComponent(imageURL)+"\', \'pinterest-share-dialog\', \'"+rowWidth+"\', \'"+rowWidth+"\')\"><img src=\""+this.socialButton+"\" width=\""+imageSize+"\"></a></div>");
		}		
};

var openWindow = function(url, name, width, height) {
	//console.log("clicked");
	window.open(url,name,"width="+width+",height="+height+"");
};
var clickPassing = function(divID){
	console.log("meggnyomva");
	jQuery(divID).click();
};
/**
 * on|off
 */
var blinkingButton = function(divID, bswitch){
	if (bswitch === "on"){
		var width = jQuery(divID).width()+parseInt(jQuery(divID).css('padding-left').toString().replace("px", ""))+parseInt(jQuery(divID).css('padding-right').toString().replace("px", ""));
		var height = jQuery(divID).height();
		var left = jQuery(divID).position().left;
		var href = "href=\""+jQuery("#"+jQuery(divID).attr('id')).find("a").attr("href")+"\"";
		if (href === "href=\"undefined\"")
			href = "";
		var onclick = "onclick=\""+jQuery("#"+jQuery(divID).attr('id')).find("a").attr("onclick")+"\"";
		if (onclick === "onclick=\"undefined\"")
			onclick = "";
		jQuery(divID).prepend("<a "+href+" "+onclick+" id=\""+jQuery(divID).attr('id')+"blink"+"\" style=\"width:"+width+"px; height: "+height+"px; background-color: #000000; position: absolute; left: "+left+"; opacity: 0.5;\"></a>");
	} else if (bswitch === "off"){
		jQuery("#"+jQuery(divID).attr('id')+"blink").remove();
	} else {
		//végigfuttatni az elsötétítést a divID-ban lévő cellákon
		
	}
		
};

jQuery('div').each(function() {
	if (jQuery(this).attr('id') === 'social'){
		//console.log('megvan');
	    var url = jQuery(this).attr('posturl');
	    var title = jQuery(this).attr('posttitle');
	    var imageURL =  jQuery(this).attr('imageurl');
	    var rowWidth = jQuery(this).parent().width();
	    var containerHeight = jQuery(this).parent().height();
	    var socialButtonCount = 0;
	    var cellIDSPrefix = "sb" + Math.floor((Math.random() * 100000) + 1);
	    for (i = 0; i < socials.length; i++) {
	    	if (typeof jQuery(this).attr(socials[i]) !== typeof undefined && jQuery(this).attr(socials[i]) !== false) {
	    		window[socials[i]].isDisplay = true;
		        socialButtonCount++;
		    }
	    }
	    
	    var imageSize = rowWidth/socialButtonCount;
	    var padding = 0;
	    var rowNum = 1;
	    while (imageSize < buttonMinWidth){
	    	rowNum++;
	    	imageSize = rowWidth/(socialButtonCount/rowNum);
	    	
	    }

	    if (imageSize > buttonMaxWidth){
	    	imageSize = buttonMaxWidth;
	    }
	    
	    //console.log("imageSize: "+imageSize);
	    //console.log("padding: "+padding);
	    jQuery(this).css({'margin-top': '0px'});
	    jQuery(this).before("<div style=\"background-color: #000000; color: #ffffff; margin-top: 3px; padding-bottom: 2px;\"><div>Megosztom másokkal, hogy jól érezzék magukat :)</div>");
	    jQuery(this).append("<div style=\"display: table;\">");
	    jQuery(this).append("<div style=\"display: table-row;\">");
	    var enter = 0;
	    var buttonIDsInRow = [];
	    for (i = 0; i < socials.length; i++) {
	    	if (window[socials[i]].isDisplay){
	    		console.log("enter: "+enter);
	    		if(enter+imageSize > rowWidth){
	    			jQuery(this).append("</div></div>");
	    			//console.log("buttonIDsInRow.length1: "+buttonIDsInRow.length);
	    			var currentPadding = ((rowWidth-(buttonIDsInRow.length*imageSize))/buttonIDsInRow.length)/2;
	    			for (j = 0; j < buttonIDsInRow.length; j++){
	    				jQuery('#'+buttonIDsInRow[j]).css({'padding-left': currentPadding+"px", 'padding-right': currentPadding+"px"});
	    				jQuery('#'+buttonIDsInRow[j])
	    				.mouseenter(function() {
	    					//console.log("mouseenter "+jQuery(this).attr("id"));
	    					blinkingButton(jQuery(this), "on");
	    				})
	    				.mouseleave(function() {
	    					//console.log("mouseleave "+jQuery(this).attr("id"));
	    					blinkingButton(jQuery(this), "off");
	    				});
	    			}
	    			buttonIDsInRow = [];
	    			jQuery(this).append("<div style=\"display: table;\"><div style=\"display: table-row;\">");
	    			enter = imageSize;
		    	} else{
		    		enter += imageSize;
		    	}
	    		window[socials[i]].shareSourceCode(this, cellIDSPrefix + i.toString() ,url, imageURL, title, padding, rowWidth, imageSize);
	    		
	    		buttonIDsInRow.push(cellIDSPrefix + i.toString());
	    	}
	    }
	    jQuery(this).append("</div></div>");
	    //console.log("buttonIDsInRow.length2: "+buttonIDsInRow.length);
	    var currentPadding = ((rowWidth-(buttonIDsInRow.length*imageSize))/buttonIDsInRow.length)/2;
		for (j = 0; j < buttonIDsInRow.length; j++){
			jQuery('#'+buttonIDsInRow[j]).css({'padding-left': currentPadding+"px", 'padding-right': currentPadding+"px"});
			jQuery('#'+buttonIDsInRow[j])
			.mouseenter(function() {
				//console.log("mouseenter "+jQuery(this).attr("id"));
				blinkingButton(jQuery(this), "on");
			})
			.mouseleave(function() {
				//console.log("mouseleave "+jQuery(this).attr("id"));
				blinkingButton(jQuery(this), "off");
			});
		}
		buttonIDsInRow = [];
	}
});


